## xpra-4.2.tar.gz

=== packaging/buildah/opt/nvenc/Samples/CMakeLists.txt ===
# Copyright 2020 NVIDIA Corporation.  All rights reserved.
#
# Please refer to the NVIDIA end user license agreement (EULA) associated
# with this source code for terms and conditions that govern your use of
# this software. Any use, reproduction, disclosure, or distribution of
# this software and related documentation outside the terms of the EULA
# is strictly prohibited.

# 3.7 is required for FindVulkan module support in CMake.
cmake_minimum_required(VERSION 3.7)

project(NvCodec)

# Set C++11 for all projects and disable non-standard extensions
set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

set(CMAKE_INSTALL_PREFIX .)

set(NVCODEC_PUBLIC_INTERFACE_DIR ${CMAKE_CURRENT_SOURCE_DIR}/../Interface)
set(NVCODEC_UTILS_DIR ${CMAKE_CURRENT_SOURCE_DIR}/Utils)
set(NV_CODEC_DIR ${CMAKE_CURRENT_SOURCE_DIR}/NvCodec)
set(NV_ENC_DIR ${CMAKE_CURRENT_SOURCE_DIR}/NvCodec/NvEncoder)
set(NV_DEC_DIR ${CMAKE_CURRENT_SOURCE_DIR}/NvCodec/NvDecoder)
set(NV_APPENC_COMMON_DIR ${CMAKE_CURRENT_SOURCE_DIR}/AppEncode/Common)
set(NV_APPDEC_COMMON_DIR  ${CMAKE_CURRENT_SOURCE_DIR}/AppDecode/Common)

 if(CMAKE_SIZEOF_VOID_P EQUAL 8)
    set(NVCODEC_SAMPLES_INSTALL_DIR ${CMAKE_BINARY_DIR})
else()
    set(NVCODEC_SAMPLES_INSTALL_DIR ${CMAKE_BINARY_DIR})
endif()

if(WIN32)
    if(CMAKE_SIZEOF_VOID_P EQUAL 8)
        Set(CUVID_LIB ${CMAKE_CURRENT_SOURCE_DIR}/../Lib/x64/nvcuvid.lib)
        set(NVENCODEAPI_LIB ${CMAKE_CURRENT_SOURCE_DIR}/../Lib/x64/nvencodeapi.lib)
    else()
        Set(CUVID_LIB ${CMAKE_CURRENT_SOURCE_DIR}/../Lib/Win32/nvcuvid.lib)
        set(NVENCODEAPI_LIB ${CMAKE_CURRENT_SOURCE_DIR}/../Lib/Win32/nvencodeapi.lib)
    endif()
else ()
    find_library(CUVID_LIB nvcuvid)
    find_library(NVENCODEAPI_LIB nvidia-encode)
endif()

if(CMAKE_SYSTEM_NAME STREQUAL "Linux")
    find_package(PkgConfig REQUIRED)
    pkg_check_modules(PC_AVCODEC REQUIRED IMPORTED_TARGET libavcodec)
    pkg_check_modules(PC_AVFORMAT REQUIRED IMPORTED_TARGET libavformat)
    pkg_check_modules(PC_AVUTIL REQUIRED IMPORTED_TARGET libavutil)
    pkg_check_modules(PC_SWRESAMPLE REQUIRED IMPORTED_TARGET libswresample)

    set(NV_FFMPEG_HDRS ${PC_AVCODEC_INCLUDE_DIRS})
    find_library(AVCODEC_LIBRARY NAMES avcodec
            HINTS
            ${PC_AVCODEC_LIBDIR}
            ${PC_AVCODEC_LIBRARY_DIRS}
            )
    find_library(AVFORMAT_LIBRARY NAMES avformat
            HINTS
            ${PC_AVFORMAT_LIBDIR}
            ${PC_AVFORMAT_LIBRARY_DIRS}
            )
    find_library(AVUTIL_LIBRARY NAMES avutil
            HINTS
            ${PC_AVUTIL_LIBDIR}
            ${PC_AVUTIL_LIBRARY_DIRS}
            )
    find_library(SWRESAMPLE_LIBRARY NAMES swresample
            HINTS
            ${PC_SWRESAMPLE_LIBDIR}
            ${PC_SWRESAMPLE_LIBRARY_DIRS}
            )
    set(AVCODEC_LIB ${AVCODEC_LIBRARY})
    set(AVFORMAT_LIB ${AVFORMAT_LIBRARY})
    set(AVUTIL_LIB ${AVUTIL_LIBRARY})
    set(SWRESAMPLE_LIB ${SWRESAMPLE_LIBRARY})
endif()


if(WIN32)
    add_subdirectory(AppEncode/AppEncD3D11)
    add_subdirectory(AppEncode/AppEncD3D9)
    add_subdirectory(AppDecode/AppDecD3D)
else ()
    #Need only linux Makefile for this
    add_subdirectory(AppEncode/AppEncGL)
endif()

add_subdirectory(AppEncode/AppEncCuda)
add_subdirectory(AppEncode/AppEncDec)
add_subdirectory(AppEncode/AppEncLowLatency)
add_subdirectory(AppEncode/AppEncME)
add_subdirectory(AppEncode/AppEncPerf)
add_subdirectory(AppEncode/AppEncQual)
add_subdirectory(AppEncode/AppMotionEstimationVkCuda)
add_subdirectory(AppTranscode/AppTrans)
add_subdirectory(AppTranscode/AppTransOneToN)
add_subdirectory(AppTranscode/AppTransPerf)
add_subdirectory(AppDecode/AppDec)
add_subdirectory(AppDecode/AppDecGL)
add_subdirectory(AppDecode/AppDecImageProvider)
add_subdirectory(AppDecode/AppDecLowLatency)
add_subdirectory(AppDecode/AppDecMem)
add_subdirectory(AppDecode/AppDecMultiFiles)
add_subdirectory(AppDecode/AppDecMultiInput)
add_subdirectory(AppDecode/AppDecPerf)

=== packaging/buildah/opt/nvenc/Samples/AppDecode/AppDec/CMakeLists.txt ===
# Copyright 2020 NVIDIA Corporation.  All rights reserved.
#
# Please refer to the NVIDIA end user license agreement (EULA) associated
# with this source code for terms and conditions that govern your use of
# this software. Any use, reproduction, disclosure, or distribution of
# this software and related documentation outside the terms of the EULA
# is strictly prohibited.

# 3.7 is required for FindVulkan module support in CMake.
cmake_minimum_required(VERSION 3.7)

project(AppDec)

set(APP_SOURCES
 ${CMAKE_CURRENT_SOURCE_DIR}/AppDec.cpp
)

set(NV_DEC_SOURCES
 ${NV_DEC_DIR}/NvDecoder.cpp
)

set(NV_DEC_HDRS
 ${NV_DEC_DIR}/NvDecoder.h
 ${NVCODEC_PUBLIC_INTERFACE_DIR}/cuviddec.h
 ${NVCODEC_PUBLIC_INTERFACE_DIR}/nvcuvid.h
 ${NVCODEC_UTILS_DIR}/NvCodecUtils.h
 ${NVCODEC_UTILS_DIR}/FFmpegDemuxer.h
 ${NV_APPDEC_COMMON_DIR}/AppDecUtils.h
)

if(WIN32)
    set(NV_FFMPEG_HDRS ${CMAKE_CURRENT_SOURCE_DIR}/../../External/FFmpeg/include)
endif()

source_group( "headers" FILES ${NV_DEC_HDRS} )
source_group( "sources" FILES ${APP_SOURCES} ${NV_DEC_SOURCES} )

find_package(CUDA)

set(CUDA_HOST_COMPILER ${CMAKE_CXX_COMPILER})

set(CUDA_NVCC_FLAGS ${CUDA_NVCC_FLAGS};-gencode arch=compute_50,code=\"sm_50,compute_50\")
if ( CMAKE_COMPILER_IS_GNUCC )
    if(NOT "${CUDA_NVCC_FLAGS}" MATCHES "-std=c\\+\\+11" )
        list(APPEND CUDA_NVCC_FLAGS -std=c++11)
    endif()
endif()

if(MSVC)
    add_definitions(-D_CRT_SECURE_NO_WARNINGS)
endif()

cuda_add_executable(${PROJECT_NAME}  ${APP_SOURCES} ${NV_DEC_SOURCES} ${NV_DEC_HDRS})

set_target_properties(${PROJECT_NAME} PROPERTIES CUDA_SEPARABLE_COMPILATION ON)

target_include_directories(${PROJECT_NAME} PUBLIC ${CUDA_INCLUDE_DIRS}
 ${NVCODEC_PUBLIC_INTERFACE_DIR}
 ${NVCODEC_UTILS_DIR}
 ${NV_DEC_DIR}
 ${NV_APPDEC_COMMON_DIR}
 ${NV_FFMPEG_HDRS}
 ${NV_CODEC_DIR}
)

if(WIN32)
    if(CMAKE_SIZEOF_VOID_P EQUAL 8)
        Set(AVCODEC_LIB ${CMAKE_CURRENT_SOURCE_DIR}/../../External/FFmpeg/lib/x64/avcodec.lib)
        Set(AVFORMAT_LIB ${CMAKE_CURRENT_SOURCE_DIR}/../../External/FFmpeg/lib/x64/avformat.lib)
        Set(AVUTIL_LIB ${CMAKE_CURRENT_SOURCE_DIR}/../../External/FFmpeg/lib/x64/avutil.lib)
        Set(SWRESAMPLE_LIB ${CMAKE_CURRENT_SOURCE_DIR}/../../External/FFmpeg/lib/x64/swresample.lib)
        Set(FFMPEG_DLL_DIR ${CMAKE_CURRENT_SOURCE_DIR}/../../External/FFmpeg/lib/x64/)
    else()
        Set(AVCODEC_LIB ${CMAKE_CURRENT_SOURCE_DIR}/../../External/FFmpeg/lib/Win32/avcodec.lib)
        Set(AVFORMAT_LIB ${CMAKE_CURRENT_SOURCE_DIR}/../../External/FFmpeg/lib/Win32/avformat.lib)
        Set(AVUTIL_LIB ${CMAKE_CURRENT_SOURCE_DIR}/../../External/FFmpeg/lib/Win32/avutil.lib)
        Set(SWRESAMPLE_LIB ${CMAKE_CURRENT_SOURCE_DIR}/../../External/FFmpeg/lib/Win32/swresample.lib)
        Set(FFMPEG_DLL_DIR ${CMAKE_CURRENT_SOURCE_DIR}/../../External/FFmpeg/lib/Win32/)
    endif()
    #copy dll's
    install(DIRECTORY ${FFMPEG_DLL_DIR} DESTINATION ${NVCODEC_SAMPLES_INSTALL_DIR} FILES_MATCHING PATTERN "*.dll")
endif()

target_link_libraries(${PROJECT_NAME} ${CUDA_CUDA_LIBRARY} ${CMAKE_DL_LIBS} ${NVENCODEAPI_LIB} ${CUVID_LIB} ${AVCODEC_LIB}
 ${AVFORMAT_LIB} ${AVUTIL_LIB} ${SWRESAMPLE_LIB})

install(TARGETS ${PROJECT_NAME} RUNTIME DESTINATION ${NVCODEC_SAMPLES_INSTALL_DIR})
if (MSVC)
    set_target_properties( ${PROJECT_NAME} PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${NVCODEC_SAMPLES_INSTALL_DIR}/$<CONFIG>/ )
    add_custom_command(TARGET ${PROJECT_NAME} POST_BUILD  COMMAND ${CMAKE_COMMAND} -E copy_directory ${FFMPEG_DLL_DIR} ${NVCODEC_SAMPLES_INSTALL_DIR}/$<CONFIG>/)
    #copy pdb's
    install(FILES $<TARGET_PDB_FILE:${PROJECT_NAME}> DESTINATION ${NVCODEC_SAMPLES_INSTALL_DIR}  CONFIGURATIONS Debug)
endif()

=== packaging/buildah/opt/nvenc/Samples/AppDecode/AppDecD3D/CMakeLists.txt ===
# Copyright 2020 NVIDIA Corporation.  All rights reserved.
#
# Please refer to the NVIDIA end user license agreement (EULA) associated
# with this source code for terms and conditions that govern your use of
# this software. Any use, reproduction, disclosure, or distribution of
# this software and related documentation outside the terms of the EULA
# is strictly prohibited.

# 3.7 is required for FindVulkan module support in CMake.
cmake_minimum_required(VERSION 3.7)

project(AppDecD3D)

set(APP_SOURCES
 ${CMAKE_CURRENT_SOURCE_DIR}/AppDecD3D.cpp
)

if(WIN32)
    set(NV_FFMPEG_HDRS ${CMAKE_CURRENT_SOURCE_DIR}/../../External/FFmpeg/include)
endif()

set(NV_DEC_SOURCES
 ${NV_DEC_DIR}/NvDecoder.cpp
)

set(NV_ENC_CUDA_UTILS
 ${NVCODEC_UTILS_DIR}/ColorSpace.cu
)

set(NV_DEC_COMMON_HDR_DIR  ${CMAKE_CURRENT_SOURCE_DIR}/../Common)

set(NV_DEC_HDRS
 ${NV_DEC_DIR}/NvDecoder.h
 ${NVCODEC_PUBLIC_INTERFACE_DIR}/cuviddec.h
 ${NVCODEC_PUBLIC_INTERFACE_DIR}/nvcuvid.h
 ${NVCODEC_UTILS_DIR}/NvCodecUtils.h
 ${NVCODEC_UTILS_DIR}/FFmpegDemuxer.h
 ${NVCODEC_UTILS_DIR}/ColorSpace.h
 ${NV_APPDEC_COMMON_DIR}/AppDecUtils.h
)

source_group( "headers" FILES ${NV_DEC_HDRS} )
source_group( "sources" FILES ${APP_SOURCES} ${NV_DEC_SOURCES} ${NV_ENC_CUDA_UTILS})

find_package(CUDA)

set(CUDA_HOST_COMPILER ${CMAKE_CXX_COMPILER})

set(CUDA_NVCC_FLAGS ${CUDA_NVCC_FLAGS};-gencode arch=compute_50,code=\"sm_50,compute_50\")
if ( CMAKE_COMPILER_IS_GNUCC )
    if(NOT "${CUDA_NVCC_FLAGS}" MATCHES "-std=c\\+\\+11" )
        list(APPEND CUDA_NVCC_FLAGS -std=c++11)
    endif()
endif()

if(MSVC)
    add_definitions(-D_CRT_SECURE_NO_WARNINGS)
endif()

cuda_add_executable(${PROJECT_NAME}  ${APP_SOURCES} ${NV_DEC_SOURCES} ${NV_DEC_HDRS} ${NV_ENC_CUDA_UTILS})

set_target_properties(${PROJECT_NAME} PROPERTIES CUDA_SEPARABLE_COMPILATION ON)

target_include_directories(${PROJECT_NAME} PUBLIC ${CUDA_INCLUDE_DIRS}
 ${NVCODEC_PUBLIC_INTERFACE_DIR}
 ${NVCODEC_UTILS_DIR}
 ${NV_CODEC_DIR}
 ${NV_APPDEC_COMMON_DIR}
 ${NV_FFMPEG_HDRS}
)

set(D3D9_LIBS d3d9.lib dxva2.lib d3dcompiler.lib)
set(D3D11_LIBS d3d11.lib dxgi.lib d3dcompiler.lib)

if(WIN32)
    if(CMAKE_SIZEOF_VOID_P EQUAL 8)
        Set(AVCODEC_LIB ${CMAKE_CURRENT_SOURCE_DIR}/../../External/FFmpeg/lib/x64/avcodec.lib)
        Set(AVFORMAT_LIB ${CMAKE_CURRENT_SOURCE_DIR}/../../External/FFmpeg/lib/x64/avformat.lib)
        Set(AVUTIL_LIB ${CMAKE_CURRENT_SOURCE_DIR}/../../External/FFmpeg/lib/x64/avutil.lib)
        Set(SWRESAMPLE_LIB ${CMAKE_CURRENT_SOURCE_DIR}/../../External/FFmpeg/lib/x64/swresample.lib)
        Set(FFMPEG_DLL_DIR ${CMAKE_CURRENT_SOURCE_DIR}/../../External/FFmpeg/lib/x64/)
     else()
        Set(AVCODEC_LIB ${CMAKE_CURRENT_SOURCE_DIR}/../../External/FFmpeg/lib/Win32/avcodec.lib)
        Set(AVFORMAT_LIB ${CMAKE_CURRENT_SOURCE_DIR}/../../External/FFmpeg/lib/Win32/avformat.lib)
        Set(AVUTIL_LIB ${CMAKE_CURRENT_SOURCE_DIR}/../../External/FFmpeg/lib/Win32/avutil.lib)
        Set(SWRESAMPLE_LIB ${CMAKE_CURRENT_SOURCE_DIR}/../../External/FFmpeg/lib/Win32/swresample.lib)
        Set(FFMPEG_DLL_DIR ${CMAKE_CURRENT_SOURCE_DIR}/../../External/FFmpeg/lib/Win32/)
    endif()
    #copy dll's
    install(DIRECTORY ${FFMPEG_DLL_DIR} DESTINATION ${NVCODEC_SAMPLES_INSTALL_DIR} FILES_MATCHING PATTERN "*.dll")
endif ()

target_link_libraries(${PROJECT_NAME} ${CUDA_CUDA_LIBRARY} ${CMAKE_DL_LIBS} ${NVENCODEAPI_LIB} ${CUVID_LIB} ${AVCODEC_LIB}
 ${AVFORMAT_LIB} ${AVUTIL_LIB} ${SWRESAMPLE_LIB} ${D3D9_LIBS} ${D3D11_LIBS})

install(TARGETS ${PROJECT_NAME} RUNTIME DESTINATION ${NVCODEC_SAMPLES_INSTALL_DIR})
if (MSVC)
    set_target_properties( ${PROJECT_NAME} PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${NVCODEC_SAMPLES_INSTALL_DIR}/$<CONFIG>/ )
    add_custom_command(TARGET ${PROJECT_NAME} POST_BUILD  COMMAND ${CMAKE_COMMAND} -E copy_directory ${FFMPEG_DLL_DIR} ${NVCODEC_SAMPLES_INSTALL_DIR}/$<CONFIG>/)
    #copy pdb's
    install(FILES $<TARGET_PDB_FILE:${PROJECT_NAME}> DESTINATION ${NVCODEC_SAMPLES_INSTALL_DIR}  CONFIGURATIONS Debug)
endif()

=== packaging/buildah/opt/nvenc/Samples/AppDecode/AppDecGL/CMakeLists.txt ===
# Copyright 2020 NVIDIA Corporation.  All rights reserved.
#
# Please refer to the NVIDIA end user license agreement (EULA) associated
# with this source code for terms and conditions that govern your use of
# this software. Any use, reproduction, disclosure, or distribution of
# this software and related documentation outside the terms of the EULA
# is strictly prohibited.

# 3.7 is required for FindVulkan module support in CMake.
cmake_minimum_required(VERSION 3.7)

project(AppDecGL)

if(WIN32)
    set(APP_SOURCES
        ${CMAKE_CURRENT_SOURCE_DIR}/AppDecGL.cpp
    )
    set(NV_FFMPEG_HDRS ${CMAKE_CURRENT_SOURCE_DIR}/../../External/FFmpeg/include)
else ()
    set(APP_SOURCES
        ${CMAKE_CURRENT_SOURCE_DIR}/AppDecGL.cpp
        ${CMAKE_CURRENT_SOURCE_DIR}/FramePresenterGLX.cpp
    )
endif()

if(WIN32)
    set(NV_GL_HDRS ${CMAKE_CURRENT_SOURCE_DIR}/../../External/)
else ()
    set(NV_GL_HDRS "")
endif()

set(NV_DEC_SOURCES
 ${NV_DEC_DIR}/NvDecoder.cpp
)

set(NV_ENC_CUDA_UTILS
 ${NVCODEC_UTILS_DIR}/ColorSpace.cu
)

set(NV_DEC_HDRS
 ${NV_DEC_DIR}/NvDecoder.h
 ${NVCODEC_PUBLIC_INTERFACE_DIR}/cuviddec.h
 ${NVCODEC_PUBLIC_INTERFACE_DIR}/nvcuvid.h
 ${NVCODEC_UTILS_DIR}/NvCodecUtils.h
 ${NVCODEC_UTILS_DIR}/FFmpegDemuxer.h
 ${NVCODEC_UTILS_DIR}/ColorSpace.h
 ${NV_APPDEC_COMMON_DIR}/AppDecUtils.h
 ${CMAKE_CURRENT_SOURCE_DIR}/FramePresenter.h
 ${CMAKE_CURRENT_SOURCE_DIR}/FramePresenterGLUT.h
)

if(CMAKE_SYSTEM_NAME STREQUAL "Linux")
    set(NV_DEC_HDRS ${NV_DEC_HDRS} ${CMAKE_CURRENT_SOURCE_DIR}/FramePresenterGLX.h)
endif()

source_group( "headers" FILES ${NV_DEC_HDRS})
source_group( "sources" FILES ${APP_SOURCES} ${NV_DEC_SOURCES} ${NV_ENC_CUDA_UTILS})

find_package(CUDA)

set(CUDA_HOST_COMPILER ${CMAKE_CXX_COMPILER})

set(CUDA_NVCC_FLAGS ${CUDA_NVCC_FLAGS};-gencode arch=compute_50,code=\"sm_50,compute_50\")
if ( CMAKE_COMPILER_IS_GNUCC )
    if(NOT "${CUDA_NVCC_FLAGS}" MATCHES "-std=c\\+\\+11" )
        list(APPEND CUDA_NVCC_FLAGS -std=c++11)
    endif()
endif()

cuda_add_executable(${PROJECT_NAME}  ${APP_SOURCES} ${NV_DEC_SOURCES} ${NV_DEC_HDRS} ${NV_ENC_CUDA_UTILS})

set_target_properties(${PROJECT_NAME} PROPERTIES CUDA_SEPARABLE_COMPILATION ON)

target_include_directories(${PROJECT_NAME} PUBLIC ${CUDA_INCLUDE_DIRS}
 ${NVCODEC_PUBLIC_INTERFACE_DIR}
 ${NVCODEC_UTILS_DIR}
 ${NV_CODEC_DIR}
 ${NV_APPDEC_COMMON_DIR}
 ${NV_FFMPEG_HDRS}
 ${NV_GL_HDRS}
)

if(WIN32)
    if(CMAKE_SIZEOF_VOID_P EQUAL 8)
        Set(AVCODEC_LIB ${CMAKE_CURRENT_SOURCE_DIR}/../../External/FFmpeg/lib/x64/avcodec.lib)
        Set(AVFORMAT_LIB ${CMAKE_CURRENT_SOURCE_DIR}/../../External/FFmpeg/lib/x64/avformat.lib)
        Set(AVUTIL_LIB ${CMAKE_CURRENT_SOURCE_DIR}/../../External/FFmpeg/lib/x64/avutil.lib)
        Set(SWRESAMPLE_LIB ${CMAKE_CURRENT_SOURCE_DIR}/../../External/FFmpeg/lib/x64/swresample.lib)
        Set(FREEGLUT_LIB ${CMAKE_CURRENT_SOURCE_DIR}/../../External/GL/lib/x64/freeglut.lib)
        Set(FREEGLUT_STATIC_LIB ${CMAKE_CURRENT_SOURCE_DIR}/../../External/GL/lib/x64/freeglut_static.lib)
        Set(FREEGLUT_STATICD_LIB ${CMAKE_CURRENT_SOURCE_DIR}/../../External/GL/lib/x64/freeglut_staticd.lib)
        Set(FREEGLUTD_LIB ${CMAKE_CURRENT_SOURCE_DIR}/../../External/GL/lib/x64/freeglutd.lib)
        Set(GLEW32_LIB ${CMAKE_CURRENT_SOURCE_DIR}/../../External/GL/lib/x64/glew32.lib)
        Set(GLEW32S_LIB ${CMAKE_CURRENT_SOURCE_DIR}/../../External/GL/lib/x64/glew32s.lib)
        Set(FFMPEG_DLL_DIR ${CMAKE_CURRENT_SOURCE_DIR}/../../External/FFmpeg/lib/x64/)
        Set(GL_DLL_DIR ${CMAKE_CURRENT_SOURCE_DIR}/../../External/GL/lib/x64/)
     else()
        Set(AVCODEC_LIB ${CMAKE_CURRENT_SOURCE_DIR}/../../External/FFmpeg/lib/Win32/avcodec.lib)
        Set(AVFORMAT_LIB ${CMAKE_CURRENT_SOURCE_DIR}/../../External/FFmpeg/lib/Win32/avformat.lib)
        Set(AVUTIL_LIB ${CMAKE_CURRENT_SOURCE_DIR}/../../External/FFmpeg/lib/Win32/avutil.lib)
        Set(SWRESAMPLE_LIB ${CMAKE_CURRENT_SOURCE_DIR}/../../External/FFmpeg/lib/Win32/swresample.lib)
        Set(FREEGLUT_LIB ${CMAKE_CURRENT_SOURCE_DIR}/../../External/GL/lib/Win32/freeglut.lib)
        Set(FREEGLUT_STATIC_LIB ${CMAKE_CURRENT_SOURCE_DIR}/../../External/GL/lib/Win32/freeglut_static.lib)
        Set(FREEGLUT_STATICD_LIB ${CMAKE_CURRENT_SOURCE_DIR}/../../External/GL/lib/Win32/freeglut_staticd.lib)
        Set(FREEGLUTD_LIB ${CMAKE_CURRENT_SOURCE_DIR}/../../External/GL/lib/Win32/freeglutd.lib)
        Set(GLEW32_LIB ${CMAKE_CURRENT_SOURCE_DIR}/../../External/GL/lib/Win32/glew32.lib)
        Set(GLEW32S_LIB ${CMAKE_CURRENT_SOURCE_DIR}/../../External/GL/lib/Win32/glew32s.lib)
        Set(FFMPEG_DLL_DIR ${CMAKE_CURRENT_SOURCE_DIR}/../../External/FFmpeg/lib/Win32/)
        Set(GL_DLL_DIR ${CMAKE_CURRENT_SOURCE_DIR}/../../External/GL/lib/Win32/)
    endif()
    #copy dll's
    install(DIRECTORY ${FFMPEG_DLL_DIR} DESTINATION ${NVCODEC_SAMPLES_INSTALL_DIR} FILES_MATCHING PATTERN "*.dll")
    install(DIRECTORY ${GL_DLL_DIR} DESTINATION ${NVCODEC_SAMPLES_INSTALL_DIR} FILES_MATCHING PATTERN "*.dll")
    target_link_libraries(${PROJECT_NAME} ${CUDA_CUDA_LIBRARY} ${CMAKE_DL_LIBS} ${NVENCODEAPI_LIB} ${CUVID_LIB} ${AVCODEC_LIB}
        ${AVFORMAT_LIB} ${AVUTIL_LIB} ${SWRESAMPLE_LIB} ${FREEGLUT_LIB} ${FREEGLUT_STATIC_LIB} ${FREEGLUT_STATICD_LIB}
        ${FREEGLUTD_LIB} ${GLEW32_LIB} ${GLEW32S_LIB})
else ()
    find_library(FREEGLUT_LIB glut)
    find_library(GLEW32_LIB GLEW)
    find_library(X11_LIB X11)
    find_library(GL_LIB GL)
    find_library(CUDART_LIB cudart HINTS ${CUDA_TOOLKIT_ROOT_DIR}/lib64)
    target_link_libraries(${PROJECT_NAME} ${CUDA_CUDA_LIBRARY} ${CUDART_LIB} ${CMAKE_DL_LIBS} ${NVENCODEAPI_LIB} ${CUVID_LIB} ${AVCODEC_LIB}
        ${AVFORMAT_LIB} ${AVUTIL_LIB} ${SWRESAMPLE_LIB} ${FREEGLUT_LIB} ${GLEW32_LIB} ${X11_LIB} ${GL_LIB})
endif()

install(TARGETS ${PROJECT_NAME} RUNTIME DESTINATION ${NVCODEC_SAMPLES_INSTALL_DIR})
if (MSVC)
    add_definitions(-D_CRT_SECURE_NO_WARNINGS)
    set_target_properties( ${PROJECT_NAME} PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${NVCODEC_SAMPLES_INSTALL_DIR}/$<CONFIG>/ )
    add_custom_command(TARGET ${PROJECT_NAME} POST_BUILD  COMMAND ${CMAKE_COMMAND} -E copy_directory ${FFMPEG_DLL_DIR} ${NVCODEC_SAMPLES_INSTALL_DIR}/$<CONFIG>/)
    add_custom_command(TARGET ${PROJECT_NAME} POST_BUILD  COMMAND ${CMAKE_COMMAND} -E copy_directory ${GL_DLL_DIR} ${NVCODEC_SAMPLES_INSTALL_DIR}/$<CONFIG>/)
    #copy pdb's
    install(FILES $<TARGET_PDB_FILE:${PROJECT_NAME}> DESTINATION ${NVCODEC_SAMPLES_INSTALL_DIR}  CONFIGURATIONS Debug)
endif()

=== packaging/buildah/opt/nvenc/Samples/AppDecode/AppDecImageProvider/CMakeLists.txt ===
# Copyright 2020 NVIDIA Corporation.  All rights reserved.
#
# Please refer to the NVIDIA end user license agreement (EULA) associated
# with this source code for terms and conditions that govern your use of
# this software. Any use, reproduction, disclosure, or distribution of
# this software and related documentation outside the terms of the EULA
# is strictly prohibited.

# 3.7 is required for FindVulkan module support in CMake.
cmake_minimum_required(VERSION 3.7)

project(AppDecImageProvider)

set(APP_SOURCES
 ${CMAKE_CURRENT_SOURCE_DIR}/AppDecImageProvider.cpp
)

if(WIN32)
    set(NV_FFMPEG_HDRS ${CMAKE_CURRENT_SOURCE_DIR}/../../External/FFmpeg/include)
endif()

set(NV_DEC_SOURCES
 ${NV_DEC_DIR}/NvDecoder.cpp
)

set(NV_ENC_CUDA_UTILS
 ${NVCODEC_UTILS_DIR}/ColorSpace.cu
)

set(NV_DEC_HDRS
 ${NV_DEC_DIR}/NvDecoder.h
 ${NVCODEC_PUBLIC_INTERFACE_DIR}/cuviddec.h
 ${NVCODEC_PUBLIC_INTERFACE_DIR}/nvcuvid.h
 ${NVCODEC_UTILS_DIR}/NvCodecUtils.h
 ${NVCODEC_UTILS_DIR}/FFmpegDemuxer.h
 ${NVCODEC_UTILS_DIR}/ColorSpace.h
 ${NV_APPDEC_COMMON_DIR}/AppDecUtils.h
)

source_group( "headers" FILES ${NV_DEC_HDRS} )
source_group( "sources" FILES ${APP_SOURCES} ${NV_DEC_SOURCES} ${NV_ENC_CUDA_UTILS})

find_package(CUDA)

set(CUDA_HOST_COMPILER ${CMAKE_CXX_COMPILER})

set(CUDA_NVCC_FLAGS ${CUDA_NVCC_FLAGS};-gencode arch=compute_50,code=\"sm_50,compute_50\")
if ( CMAKE_COMPILER_IS_GNUCC )
    if(NOT "${CUDA_NVCC_FLAGS}" MATCHES "-std=c\\+\\+11" )
        list(APPEND CUDA_NVCC_FLAGS -std=c++11)
    endif()
endif()

cuda_add_executable(${PROJECT_NAME}  ${APP_SOURCES} ${NV_DEC_SOURCES} ${NV_DEC_HDRS} ${NV_ENC_CUDA_UTILS})

set_target_properties(${PROJECT_NAME} PROPERTIES CUDA_SEPARABLE_COMPILATION ON)

target_include_directories(${PROJECT_NAME} PUBLIC ${CUDA_INCLUDE_DIRS}
 ${NVCODEC_PUBLIC_INTERFACE_DIR}
 ${NVCODEC_UTILS_DIR}
 ${NV_CODEC_DIR}
 ${NV_APPDEC_COMMON_DIR}
 ${NV_FFMPEG_HDRS}
)

if(WIN32)
    if(CMAKE_SIZEOF_VOID_P EQUAL 8)
        Set(AVCODEC_LIB ${CMAKE_CURRENT_SOURCE_DIR}/../../External/FFmpeg/lib/x64/avcodec.lib)
        Set(AVFORMAT_LIB ${CMAKE_CURRENT_SOURCE_DIR}/../../External/FFmpeg/lib/x64/avformat.lib)
        Set(AVUTIL_LIB ${CMAKE_CURRENT_SOURCE_DIR}/../../External/FFmpeg/lib/x64/avutil.lib)
        Set(SWRESAMPLE_LIB ${CMAKE_CURRENT_SOURCE_DIR}/../../External/FFmpeg/lib/x64/swresample.lib)
        Set(FFMPEG_DLL_DIR ${CMAKE_CURRENT_SOURCE_DIR}/../../External/FFmpeg/lib/x64/)
     else()
        Set(AVCODEC_LIB ${CMAKE_CURRENT_SOURCE_DIR}/../../External/FFmpeg/lib/Win32/avcodec.lib)
        Set(AVFORMAT_LIB ${CMAKE_CURRENT_SOURCE_DIR}/../../External/FFmpeg/lib/Win32/avformat.lib)
        Set(AVUTIL_LIB ${CMAKE_CURRENT_SOURCE_DIR}/../../External/FFmpeg/lib/Win32/avutil.lib)
        Set(SWRESAMPLE_LIB ${CMAKE_CURRENT_SOURCE_DIR}/../../External/FFmpeg/lib/Win32/swresample.lib)
        Set(FFMPEG_DLL_DIR ${CMAKE_CURRENT_SOURCE_DIR}/../../External/FFmpeg/lib/Win32/)
    endif()
    #copy dll's
    install(DIRECTORY ${FFMPEG_DLL_DIR} DESTINATION ${NVCODEC_SAMPLES_INSTALL_DIR} FILES_MATCHING PATTERN "*.dll")
endif ()

target_link_libraries(${PROJECT_NAME} ${CUDA_CUDA_LIBRARY} ${CMAKE_DL_LIBS} ${NVENCODEAPI_LIB} ${CUVID_LIB} ${AVCODEC_LIB}
 ${AVFORMAT_LIB} ${AVUTIL_LIB} ${SWRESAMPLE_LIB} )

install(TARGETS ${PROJECT_NAME} RUNTIME DESTINATION ${NVCODEC_SAMPLES_INSTALL_DIR})
if (MSVC)
    add_definitions(-D_CRT_SECURE_NO_WARNINGS)
    set_target_properties( ${PROJECT_NAME} PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${NVCODEC_SAMPLES_INSTALL_DIR}/$<CONFIG>/ )
    add_custom_command(TARGET ${PROJECT_NAME} POST_BUILD  COMMAND ${CMAKE_COMMAND} -E copy_directory ${FFMPEG_DLL_DIR} ${NVCODEC_SAMPLES_INSTALL_DIR}/$<CONFIG>/)
    #copy pdb's
    install(FILES $<TARGET_PDB_FILE:${PROJECT_NAME}> DESTINATION ${NVCODEC_SAMPLES_INSTALL_DIR}  CONFIGURATIONS Debug)
endif()

=== packaging/buildah/opt/nvenc/Samples/AppDecode/AppDecLowLatency/CMakeLists.txt ===
# Copyright 2020 NVIDIA Corporation.  All rights reserved.
#
# Please refer to the NVIDIA end user license agreement (EULA) associated
# with this source code for terms and conditions that govern your use of
# this software. Any use, reproduction, disclosure, or distribution of
# this software and related documentation outside the terms of the EULA
# is strictly prohibited.

# 3.7 is required for FindVulkan module support in CMake.
cmake_minimum_required(VERSION 3.7)

project(AppDecLowLatency)

set(APP_SOURCES
 ${CMAKE_CURRENT_SOURCE_DIR}/AppDecLowLatency.cpp
)

if(WIN32)
    set(NV_FFMPEG_HDRS ${CMAKE_CURRENT_SOURCE_DIR}/../../External/FFmpeg/include)
endif()

set(NV_DEC_SOURCES
 ${NV_DEC_DIR}/NvDecoder.cpp
)

set(NV_DEC_HDRS
 ${NV_DEC_DIR}/NvDecoder.h
 ${NVCODEC_PUBLIC_INTERFACE_DIR}/cuviddec.h
 ${NVCODEC_PUBLIC_INTERFACE_DIR}/nvcuvid.h
 ${NVCODEC_UTILS_DIR}/NvCodecUtils.h
 ${NVCODEC_UTILS_DIR}/FFmpegDemuxer.h
 ${NV_APPDEC_COMMON_DIR}/AppDecUtils.h
)

source_group( "headers" FILES ${NV_DEC_HDRS} )
source_group( "sources" FILES ${APP_SOURCES} ${NV_DEC_SOURCES} ${NV_ENC_CUDA_UTILS})

find_package(CUDA)

set(CUDA_HOST_COMPILER ${CMAKE_CXX_COMPILER})

set(CUDA_NVCC_FLAGS ${CUDA_NVCC_FLAGS};-gencode arch=compute_50,code=\"sm_50,compute_50\")
if ( CMAKE_COMPILER_IS_GNUCC )
    if(NOT "${CUDA_NVCC_FLAGS}" MATCHES "-std=c\\+\\+11" )
        list(APPEND CUDA_NVCC_FLAGS -std=c++11)
    endif()
endif()

cuda_add_executable(${PROJECT_NAME}  ${APP_SOURCES} ${NV_DEC_SOURCES} ${NV_DEC_HDRS} ${NV_ENC_CUDA_UTILS})

set_target_properties(${PROJECT_NAME} PROPERTIES CUDA_SEPARABLE_COMPILATION ON)

target_include_directories(${PROJECT_NAME} PUBLIC ${CUDA_INCLUDE_DIRS}
 ${NVCODEC_PUBLIC_INTERFACE_DIR}
 ${NVCODEC_UTILS_DIR}
 ${NV_CODEC_DIR}
 ${NV_APPDEC_COMMON_DIR}
 ${NV_FFMPEG_HDRS}
)

if(WIN32)
    if(CMAKE_SIZEOF_VOID_P EQUAL 8)
        Set(AVCODEC_LIB ${CMAKE_CURRENT_SOURCE_DIR}/../../External/FFmpeg/lib/x64/avcodec.lib)
        Set(AVFORMAT_LIB ${CMAKE_CURRENT_SOURCE_DIR}/../../External/FFmpeg/lib/x64/avformat.lib)
        Set(AVUTIL_LIB ${CMAKE_CURRENT_SOURCE_DIR}/../../External/FFmpeg/lib/x64/avutil.lib)
        Set(SWRESAMPLE_LIB ${CMAKE_CURRENT_SOURCE_DIR}/../../External/FFmpeg/lib/x64/swresample.lib)
        Set(FFMPEG_DLL_DIR ${CMAKE_CURRENT_SOURCE_DIR}/../../External/FFmpeg/lib/x64/)
     else()
        Set(AVCODEC_LIB ${CMAKE_CURRENT_SOURCE_DIR}/../../External/FFmpeg/lib/Win32/avcodec.lib)
        Set(AVFORMAT_LIB ${CMAKE_CURRENT_SOURCE_DIR}/../../External/FFmpeg/lib/Win32/avformat.lib)
        Set(AVUTIL_LIB ${CMAKE_CURRENT_SOURCE_DIR}/../../External/FFmpeg/lib/Win32/avutil.lib)
        Set(SWRESAMPLE_LIB ${CMAKE_CURRENT_SOURCE_DIR}/../../External/FFmpeg/lib/Win32/swresample.lib)
        Set(FFMPEG_DLL_DIR ${CMAKE_CURRENT_SOURCE_DIR}/../../External/FFmpeg/lib/Win32/)
    endif()
    #copy dll's
    install(DIRECTORY ${FFMPEG_DLL_DIR} DESTINATION ${NVCODEC_SAMPLES_INSTALL_DIR} FILES_MATCHING PATTERN "*.dll")
endif ()

target_link_libraries(${PROJECT_NAME} ${CUDA_CUDA_LIBRARY} ${CMAKE_DL_LIBS} ${NVENCODEAPI_LIB} ${CUVID_LIB} ${AVCODEC_LIB}
 ${AVFORMAT_LIB} ${AVUTIL_LIB} ${SWRESAMPLE_LIB} )

install(TARGETS ${PROJECT_NAME} RUNTIME DESTINATION ${NVCODEC_SAMPLES_INSTALL_DIR})
if (MSVC)
    add_definitions(-D_CRT_SECURE_NO_WARNINGS)
    set_target_properties( ${PROJECT_NAME} PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${NVCODEC_SAMPLES_INSTALL_DIR}/$<CONFIG>/ )
    add_custom_command(TARGET ${PROJECT_NAME} POST_BUILD  COMMAND ${CMAKE_COMMAND} -E copy_directory ${FFMPEG_DLL_DIR} ${NVCODEC_SAMPLES_INSTALL_DIR}/$<CONFIG>/)
    #copy pdb's
    install(FILES $<TARGET_PDB_FILE:${PROJECT_NAME}> DESTINATION ${NVCODEC_SAMPLES_INSTALL_DIR}  CONFIGURATIONS Debug)
endif()

=== packaging/buildah/opt/nvenc/Samples/AppDecode/AppDecMem/CMakeLists.txt ===
# Copyright 2020 NVIDIA Corporation.  All rights reserved.
#
# Please refer to the NVIDIA end user license agreement (EULA) associated
# with this source code for terms and conditions that govern your use of
# this software. Any use, reproduction, disclosure, or distribution of
# this software and related documentation outside the terms of the EULA
# is strictly prohibited.

# 3.7 is required for FindVulkan module support in CMake.
cmake_minimum_required(VERSION 3.7)

project(AppDecMem)

set(APP_SOURCES
 ${CMAKE_CURRENT_SOURCE_DIR}/AppDecMem.cpp
)

if(WIN32)
    set(NV_FFMPEG_HDRS ${CMAKE_CURRENT_SOURCE_DIR}/../../External/FFmpeg/include)
endif()

set(NV_DEC_SOURCES
 ${NV_DEC_DIR}/NvDecoder.cpp
)

set(NV_DEC_HDRS
 ${NV_DEC_DIR}/NvDecoder.h
 ${NVCODEC_PUBLIC_INTERFACE_DIR}/cuviddec.h
 ${NVCODEC_PUBLIC_INTERFACE_DIR}/nvcuvid.h
 ${NVCODEC_UTILS_DIR}/NvCodecUtils.h
 ${NVCODEC_UTILS_DIR}/FFmpegDemuxer.h
 ${NV_APPDEC_COMMON_DIR}/AppDecUtils.h
)

source_group( "headers" FILES ${NV_DEC_HDRS} )
source_group( "sources" FILES ${APP_SOURCES} ${NV_DEC_SOURCES} ${NV_ENC_CUDA_UTILS})

find_package(CUDA)

set(CUDA_HOST_COMPILER ${CMAKE_CXX_COMPILER})

set(CUDA_NVCC_FLAGS ${CUDA_NVCC_FLAGS};-gencode arch=compute_50,code=\"sm_50,compute_50\")
if ( CMAKE_COMPILER_IS_GNUCC )
    if(NOT "${CUDA_NVCC_FLAGS}" MATCHES "-std=c\\+\\+11" )
        list(APPEND CUDA_NVCC_FLAGS -std=c++11)
    endif()
endif()

cuda_add_executable(${PROJECT_NAME}  ${APP_SOURCES} ${NV_DEC_SOURCES} ${NV_DEC_HDRS} ${NV_ENC_CUDA_UTILS})

set_target_properties(${PROJECT_NAME} PROPERTIES CUDA_SEPARABLE_COMPILATION ON)

target_include_directories(${PROJECT_NAME} PUBLIC ${CUDA_INCLUDE_DIRS}
 ${NVCODEC_PUBLIC_INTERFACE_DIR}
 ${NVCODEC_UTILS_DIR}
 ${NV_CODEC_DIR}
 ${NV_APPDEC_COMMON_DIR}
 ${NV_FFMPEG_HDRS}
)

if(WIN32)
    if(CMAKE_SIZEOF_VOID_P EQUAL 8)
        Set(AVCODEC_LIB ${CMAKE_CURRENT_SOURCE_DIR}/../../External/FFmpeg/lib/x64/avcodec.lib)
        Set(AVFORMAT_LIB ${CMAKE_CURRENT_SOURCE_DIR}/../../External/FFmpeg/lib/x64/avformat.lib)
        Set(AVUTIL_LIB ${CMAKE_CURRENT_SOURCE_DIR}/../../External/FFmpeg/lib/x64/avutil.lib)
        Set(SWRESAMPLE_LIB ${CMAKE_CURRENT_SOURCE_DIR}/../../External/FFmpeg/lib/x64/swresample.lib)
        Set(FFMPEG_DLL_DIR ${CMAKE_CURRENT_SOURCE_DIR}/../../External/FFmpeg/lib/x64/)
     else()
        Set(AVCODEC_LIB ${CMAKE_CURRENT_SOURCE_DIR}/../../External/FFmpeg/lib/Win32/avcodec.lib)
        Set(AVFORMAT_LIB ${CMAKE_CURRENT_SOURCE_DIR}/../../External/FFmpeg/lib/Win32/avformat.lib)
        Set(AVUTIL_LIB ${CMAKE_CURRENT_SOURCE_DIR}/../../External/FFmpeg/lib/Win32/avutil.lib)
        Set(SWRESAMPLE_LIB ${CMAKE_CURRENT_SOURCE_DIR}/../../External/FFmpeg/lib/Win32/swresample.lib)
        Set(FFMPEG_DLL_DIR ${CMAKE_CURRENT_SOURCE_DIR}/../../External/FFmpeg/lib/Win32/)
    endif()
    #copy dll's
    install(DIRECTORY ${FFMPEG_DLL_DIR} DESTINATION ${NVCODEC_SAMPLES_INSTALL_DIR} FILES_MATCHING PATTERN "*.dll")
endif()

target_link_libraries(${PROJECT_NAME} ${CUDA_CUDA_LIBRARY} ${CMAKE_DL_LIBS} ${NVENCODEAPI_LIB} ${CUVID_LIB} ${AVCODEC_LIB}
 ${AVFORMAT_LIB} ${AVUTIL_LIB} ${SWRESAMPLE_LIB} )

install(TARGETS ${PROJECT_NAME} RUNTIME DESTINATION ${NVCODEC_SAMPLES_INSTALL_DIR})
if (MSVC)
    add_definitions(-D_CRT_SECURE_NO_WARNINGS)
    set_target_properties( ${PROJECT_NAME} PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${NVCODEC_SAMPLES_INSTALL_DIR}/$<CONFIG>/ )
    add_custom_command(TARGET ${PROJECT_NAME} POST_BUILD  COMMAND ${CMAKE_COMMAND} -E copy_directory ${FFMPEG_DLL_DIR} ${NVCODEC_SAMPLES_INSTALL_DIR}/$<CONFIG>/)
    #copy pdb's
    install(FILES $<TARGET_PDB_FILE:${PROJECT_NAME}> DESTINATION ${NVCODEC_SAMPLES_INSTALL_DIR}  CONFIGURATIONS Debug)
endif()

=== packaging/buildah/opt/nvenc/Samples/AppDecode/AppDecMultiFiles/CMakeLists.txt ===
# Copyright 2020 NVIDIA Corporation.  All rights reserved.
#
# Please refer to the NVIDIA end user license agreement (EULA) associated
# with this source code for terms and conditions that govern your use of
# this software. Any use, reproduction, disclosure, or distribution of
# this software and related documentation outside the terms of the EULA
# is strictly prohibited.

# 3.7 is required for FindVulkan module support in CMake.
cmake_minimum_required(VERSION 3.7)

project(AppDecMultiFiles)

set(APP_SOURCES
 ${CMAKE_CURRENT_SOURCE_DIR}/AppDecMultiFiles.cpp
)

if(WIN32)
    set(NV_FFMPEG_HDRS ${CMAKE_CURRENT_SOURCE_DIR}/../../External/FFmpeg/include)
endif()

set(NV_DEC_SOURCES
 ${NV_DEC_DIR}/NvDecoder.cpp
)

set(NV_DEC_COMMON_HDR_DIR  ${CMAKE_CURRENT_SOURCE_DIR}/../Common)

set(NV_DEC_HDRS
 ${NV_DEC_DIR}/NvDecoder.h
 ${NVCODEC_PUBLIC_INTERFACE_DIR}/cuviddec.h
 ${NVCODEC_PUBLIC_INTERFACE_DIR}/nvcuvid.h
 ${NVCODEC_UTILS_DIR}/NvCodecUtils.h
 ${NVCODEC_UTILS_DIR}/FFmpegDemuxer.h
 ${NV_DEC_COMMON_HDR_DIR}/AppDecUtils.h
)

source_group( "headers" FILES ${NV_DEC_HDRS} )
source_group( "sources" FILES ${APP_SOURCES} ${NV_DEC_SOURCES} ${NV_ENC_CUDA_UTILS})

find_package(CUDA)

set(CUDA_HOST_COMPILER ${CMAKE_CXX_COMPILER})

set(CUDA_NVCC_FLAGS ${CUDA_NVCC_FLAGS};-gencode arch=compute_50,code=\"sm_50,compute_50\")
if ( CMAKE_COMPILER_IS_GNUCC )
    if(NOT "${CUDA_NVCC_FLAGS}" MATCHES "-std=c\\+\\+11" )
        list(APPEND CUDA_NVCC_FLAGS -std=c++11)
    endif()
endif()

cuda_add_executable(${PROJECT_NAME}  ${APP_SOURCES} ${NV_DEC_SOURCES} ${NV_DEC_HDRS} ${NV_ENC_CUDA_UTILS})

set_target_properties(${PROJECT_NAME} PROPERTIES CUDA_SEPARABLE_COMPILATION ON)

target_include_directories(${PROJECT_NAME} PUBLIC ${CUDA_INCLUDE_DIRS}
 ${NVCODEC_PUBLIC_INTERFACE_DIR}
 ${NVCODEC_UTILS_DIR}
 ${NV_CODEC_DIR}
 ${NV_APPDEC_COMMON_DIR}
 ${NV_FFMPEG_HDRS}
)

if(WIN32)
    if(CMAKE_SIZEOF_VOID_P EQUAL 8)
        Set(AVCODEC_LIB ${CMAKE_CURRENT_SOURCE_DIR}/../../External/FFmpeg/lib/x64/avcodec.lib)
        Set(AVFORMAT_LIB ${CMAKE_CURRENT_SOURCE_DIR}/../../External/FFmpeg/lib/x64/avformat.lib)
        Set(AVUTIL_LIB ${CMAKE_CURRENT_SOURCE_DIR}/../../External/FFmpeg/lib/x64/avutil.lib)
        Set(SWRESAMPLE_LIB ${CMAKE_CURRENT_SOURCE_DIR}/../../External/FFmpeg/lib/x64/swresample.lib)
        Set(FFMPEG_DLL_DIR ${CMAKE_CURRENT_SOURCE_DIR}/../../External/FFmpeg/lib/x64/)
     else()
        Set(AVCODEC_LIB ${CMAKE_CURRENT_SOURCE_DIR}/../../External/FFmpeg/lib/Win32/avcodec.lib)
        Set(AVFORMAT_LIB ${CMAKE_CURRENT_SOURCE_DIR}/../../External/FFmpeg/lib/Win32/avformat.lib)
        Set(AVUTIL_LIB ${CMAKE_CURRENT_SOURCE_DIR}/../../External/FFmpeg/lib/Win32/avutil.lib)
        Set(SWRESAMPLE_LIB ${CMAKE_CURRENT_SOURCE_DIR}/../../External/FFmpeg/lib/Win32/swresample.lib)
        Set(FFMPEG_DLL_DIR ${CMAKE_CURRENT_SOURCE_DIR}/../../External/FFmpeg/lib/Win32/)
    endif()
    #copy dll's
    install(DIRECTORY ${FFMPEG_DLL_DIR} DESTINATION ${NVCODEC_SAMPLES_INSTALL_DIR} FILES_MATCHING PATTERN "*.dll")
endif()

target_link_libraries(${PROJECT_NAME} ${CUDA_CUDA_LIBRARY} ${CMAKE_DL_LIBS} ${NVENCODEAPI_LIB} ${CUVID_LIB} ${AVCODEC_LIB}
 ${AVFORMAT_LIB} ${AVUTIL_LIB} ${SWRESAMPLE_LIB} )

install(TARGETS ${PROJECT_NAME} RUNTIME DESTINATION ${NVCODEC_SAMPLES_INSTALL_DIR})
if (MSVC)
    add_definitions(-D_CRT_SECURE_NO_WARNINGS)
    set_target_properties( ${PROJECT_NAME} PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${NVCODEC_SAMPLES_INSTALL_DIR}/$<CONFIG>/ )
    add_custom_command(TARGET ${PROJECT_NAME} POST_BUILD  COMMAND ${CMAKE_COMMAND} -E copy_directory ${FFMPEG_DLL_DIR} ${NVCODEC_SAMPLES_INSTALL_DIR}/$<CONFIG>/)
    #copy pdb's
    install(FILES $<TARGET_PDB_FILE:${PROJECT_NAME}> DESTINATION ${NVCODEC_SAMPLES_INSTALL_DIR}  CONFIGURATIONS Debug)
endif()

=== packaging/buildah/opt/nvenc/Samples/AppDecode/AppDecMultiInput/CMakeLists.txt ===
# Copyright 2020 NVIDIA Corporation.  All rights reserved.
#
# Please refer to the NVIDIA end user license agreement (EULA) associated
# with this source code for terms and conditions that govern your use of
# this software. Any use, reproduction, disclosure, or distribution of
# this software and related documentation outside the terms of the EULA
# is strictly prohibited.

# 3.7 is required for FindVulkan module support in CMake.
cmake_minimum_required(VERSION 3.7)

project(AppDecMultiInput)

set(APP_SOURCES
 ${CMAKE_CURRENT_SOURCE_DIR}/AppDecMultiInput.cpp
 ${CMAKE_CURRENT_SOURCE_DIR}/Image.cu
)

if(WIN32)
    set(NV_FFMPEG_HDRS ${CMAKE_CURRENT_SOURCE_DIR}/../../External/FFmpeg/include)
endif()

set(NV_DEC_SOURCES
 ${NV_DEC_DIR}/NvDecoder.cpp
)

set(NV_DEC_COMMON_HDR_DIR  ${CMAKE_CURRENT_SOURCE_DIR}/../Common)

set(NV_DEC_HDRS
 ${NV_DEC_DIR}/NvDecoder.h
 ${NVCODEC_PUBLIC_INTERFACE_DIR}/cuviddec.h
 ${NVCODEC_PUBLIC_INTERFACE_DIR}/nvcuvid.h
 ${NVCODEC_UTILS_DIR}/NvCodecUtils.h
 ${NVCODEC_UTILS_DIR}/FFmpegDemuxer.h
 ${NV_DEC_COMMON_HDR_DIR}/AppDecUtils.h
)

source_group( "headers" FILES ${NV_DEC_HDRS} )
source_group( "sources" FILES ${APP_SOURCES} ${NV_DEC_SOURCES} ${NV_ENC_CUDA_UTILS})

find_package(CUDA)

set(CUDA_HOST_COMPILER ${CMAKE_CXX_COMPILER})

set(CUDA_NVCC_FLAGS ${CUDA_NVCC_FLAGS};-gencode arch=compute_50,code=\"sm_50,compute_50\")
if ( CMAKE_COMPILER_IS_GNUCC )
    if(NOT "${CUDA_NVCC_FLAGS}" MATCHES "-std=c\\+\\+11" )
        list(APPEND CUDA_NVCC_FLAGS -std=c++11)
    endif()
endif()

cuda_add_executable(${PROJECT_NAME}  ${APP_SOURCES} ${NV_DEC_SOURCES} ${NV_DEC_HDRS} ${NV_ENC_CUDA_UTILS})

set_target_properties(${PROJECT_NAME} PROPERTIES CUDA_SEPARABLE_COMPILATION ON)

target_include_directories(${PROJECT_NAME} PUBLIC ${CUDA_INCLUDE_DIRS}
 ${NVCODEC_PUBLIC_INTERFACE_DIR}
 ${NVCODEC_UTILS_DIR}
 ${NV_CODEC_DIR}
 ${NV_APPDEC_COMMON_DIR}
 ${NV_FFMPEG_HDRS}
)

if(WIN32)
    if(CMAKE_SIZEOF_VOID_P EQUAL 8)
        Set(AVCODEC_LIB ${CMAKE_CURRENT_SOURCE_DIR}/../../External/FFmpeg/lib/x64/avcodec.lib)
        Set(AVFORMAT_LIB ${CMAKE_CURRENT_SOURCE_DIR}/../../External/FFmpeg/lib/x64/avformat.lib)
        Set(AVUTIL_LIB ${CMAKE_CURRENT_SOURCE_DIR}/../../External/FFmpeg/lib/x64/avutil.lib)
        Set(SWRESAMPLE_LIB ${CMAKE_CURRENT_SOURCE_DIR}/../../External/FFmpeg/lib/x64/swresample.lib)
        Set(FFMPEG_DLL_DIR ${CMAKE_CURRENT_SOURCE_DIR}/../../External/FFmpeg/lib/x64/)
      else()
        Set(AVCODEC_LIB ${CMAKE_CURRENT_SOURCE_DIR}/../../External/FFmpeg/lib/Win32/avcodec.lib)
        Set(AVFORMAT_LIB ${CMAKE_CURRENT_SOURCE_DIR}/../../External/FFmpeg/lib/Win32/avformat.lib)
        Set(AVUTIL_LIB ${CMAKE_CURRENT_SOURCE_DIR}/../../External/FFmpeg/lib/Win32/avutil.lib)
        Set(SWRESAMPLE_LIB ${CMAKE_CURRENT_SOURCE_DIR}/../../External/FFmpeg/lib/Win32/swresample.lib)
        Set(FFMPEG_DLL_DIR ${CMAKE_CURRENT_SOURCE_DIR}/../../External/FFmpeg/lib/Win32/)
    endif()
    #copy dll's
    install(DIRECTORY ${FFMPEG_DLL_DIR} DESTINATION ${NVCODEC_SAMPLES_INSTALL_DIR} FILES_MATCHING PATTERN "*.dll")
endif()

target_link_libraries(${PROJECT_NAME} ${CUDA_CUDA_LIBRARY} ${CMAKE_DL_LIBS} ${NVENCODEAPI_LIB} ${CUVID_LIB} ${AVCODEC_LIB}
 ${AVFORMAT_LIB} ${AVUTIL_LIB} ${SWRESAMPLE_LIB} )

install(TARGETS ${PROJECT_NAME} RUNTIME DESTINATION ${NVCODEC_SAMPLES_INSTALL_DIR})
if (MSVC)
    add_definitions(-D_CRT_SECURE_NO_WARNINGS)
    set_target_properties( ${PROJECT_NAME} PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${NVCODEC_SAMPLES_INSTALL_DIR}/$<CONFIG>/ )
    add_custom_command(TARGET ${PROJECT_NAME} POST_BUILD  COMMAND ${CMAKE_COMMAND} -E copy_directory ${FFMPEG_DLL_DIR} ${NVCODEC_SAMPLES_INSTALL_DIR}/$<CONFIG>/)
    #copy pdb's
    install(FILES $<TARGET_PDB_FILE:${PROJECT_NAME}> DESTINATION ${NVCODEC_SAMPLES_INSTALL_DIR}  CONFIGURATIONS Debug)
endif()

=== packaging/buildah/opt/nvenc/Samples/AppDecode/AppDecPerf/CMakeLists.txt ===
# Copyright 2020 NVIDIA Corporation.  All rights reserved.
#
# Please refer to the NVIDIA end user license agreement (EULA) associated
# with this source code for terms and conditions that govern your use of
# this software. Any use, reproduction, disclosure, or distribution of
# this software and related documentation outside the terms of the EULA
# is strictly prohibited.

# 3.7 is required for FindVulkan module support in CMake.
cmake_minimum_required(VERSION 3.7)

project(AppDecPerf)

set(APP_SOURCES
 ${CMAKE_CURRENT_SOURCE_DIR}/AppDecPerf.cpp
)

if(WIN32)
    set(NV_FFMPEG_HDRS ${CMAKE_CURRENT_SOURCE_DIR}/../../External/FFmpeg/include)
endif()

set(NV_DEC_SOURCES
 ${NV_DEC_DIR}/NvDecoder.cpp
)

set(NV_DEC_COMMON_HDR_DIR  ${CMAKE_CURRENT_SOURCE_DIR}/../Common)

set(NV_DEC_HDRS
 ${NV_DEC_DIR}/NvDecoder.h
 ${NVCODEC_PUBLIC_INTERFACE_DIR}/cuviddec.h
 ${NVCODEC_PUBLIC_INTERFACE_DIR}/nvcuvid.h
 ${NVCODEC_UTILS_DIR}/NvCodecUtils.h
 ${NVCODEC_UTILS_DIR}/FFmpegDemuxer.h
 ${NV_DEC_COMMON_HDR_DIR}/AppDecUtils.h
)

source_group( "headers" FILES ${NV_DEC_HDRS} )
source_group( "sources" FILES ${APP_SOURCES} ${NV_DEC_SOURCES} ${NV_ENC_CUDA_UTILS})

find_package(CUDA)

set(CUDA_HOST_COMPILER ${CMAKE_CXX_COMPILER})

set(CUDA_NVCC_FLAGS ${CUDA_NVCC_FLAGS};-gencode arch=compute_50,code=\"sm_50,compute_50\")
if ( CMAKE_COMPILER_IS_GNUCC )
    if(NOT "${CUDA_NVCC_FLAGS}" MATCHES "-std=c\\+\\+11" )
        list(APPEND CUDA_NVCC_FLAGS -std=c++11)
    endif()
endif()

cuda_add_executable(${PROJECT_NAME}  ${APP_SOURCES} ${NV_DEC_SOURCES} ${NV_DEC_HDRS} ${NV_ENC_CUDA_UTILS})

set_target_properties(${PROJECT_NAME} PROPERTIES CUDA_SEPARABLE_COMPILATION ON)

target_include_directories(${PROJECT_NAME} PUBLIC ${CUDA_INCLUDE_DIRS}
 ${NVCODEC_PUBLIC_INTERFACE_DIR}
 ${NVCODEC_UTILS_DIR}
 ${NV_CODEC_DIR}
 ${NV_APPDEC_COMMON_DIR}
 ${NV_FFMPEG_HDRS}
)

if(WIN32)
    if(CMAKE_SIZEOF_VOID_P EQUAL 8)
        Set(AVCODEC_LIB ${CMAKE_CURRENT_SOURCE_DIR}/../../External/FFmpeg/lib/x64/avcodec.lib)
        Set(AVFORMAT_LIB ${CMAKE_CURRENT_SOURCE_DIR}/../../External/FFmpeg/lib/x64/avformat.lib)
        Set(AVUTIL_LIB ${CMAKE_CURRENT_SOURCE_DIR}/../../External/FFmpeg/lib/x64/avutil.lib)
        Set(SWRESAMPLE_LIB ${CMAKE_CURRENT_SOURCE_DIR}/../../External/FFmpeg/lib/x64/swresample.lib)
        Set(FFMPEG_DLL_DIR ${CMAKE_CURRENT_SOURCE_DIR}/../../External/FFmpeg/lib/x64/)
     else()
        Set(AVCODEC_LIB ${CMAKE_CURRENT_SOURCE_DIR}/../../External/FFmpeg/lib/Win32/avcodec.lib)
        Set(AVFORMAT_LIB ${CMAKE_CURRENT_SOURCE_DIR}/../../External/FFmpeg/lib/Win32/avformat.lib)
        Set(AVUTIL_LIB ${CMAKE_CURRENT_SOURCE_DIR}/../../External/FFmpeg/lib/Win32/avutil.lib)
        Set(SWRESAMPLE_LIB ${CMAKE_CURRENT_SOURCE_DIR}/../../External/FFmpeg/lib/Win32/swresample.lib)
        Set(FFMPEG_DLL_DIR ${CMAKE_CURRENT_SOURCE_DIR}/../../External/FFmpeg/lib/Win32/)
    endif()
    #copy dll's
    install(DIRECTORY ${FFMPEG_DLL_DIR} DESTINATION ${NVCODEC_SAMPLES_INSTALL_DIR} FILES_MATCHING PATTERN "*.dll")
endif()


target_link_libraries(${PROJECT_NAME} ${CUDA_CUDA_LIBRARY} ${CMAKE_DL_LIBS} ${NVENCODEAPI_LIB} ${CUVID_LIB} ${AVCODEC_LIB}
 ${AVFORMAT_LIB} ${AVUTIL_LIB} ${SWRESAMPLE_LIB} )

install(TARGETS ${PROJECT_NAME} RUNTIME DESTINATION ${NVCODEC_SAMPLES_INSTALL_DIR})
if (MSVC)
    add_definitions(-D_CRT_SECURE_NO_WARNINGS)
    set_target_properties( ${PROJECT_NAME} PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${NVCODEC_SAMPLES_INSTALL_DIR}/$<CONFIG>/ )
    add_custom_command(TARGET ${PROJECT_NAME} POST_BUILD  COMMAND ${CMAKE_COMMAND} -E copy_directory ${FFMPEG_DLL_DIR} ${NVCODEC_SAMPLES_INSTALL_DIR}/$<CONFIG>/)
    #copy pdb's
    install(FILES $<TARGET_PDB_FILE:${PROJECT_NAME}> DESTINATION ${NVCODEC_SAMPLES_INSTALL_DIR}  CONFIGURATIONS Debug)
endif()

=== packaging/buildah/opt/nvenc/Samples/AppEncode/AppEncCuda/CMakeLists.txt ===
# Copyright 2020 NVIDIA Corporation.  All rights reserved.
#
# Please refer to the NVIDIA end user license agreement (EULA) associated
# with this source code for terms and conditions that govern your use of
# this software. Any use, reproduction, disclosure, or distribution of
# this software and related documentation outside the terms of the EULA
# is strictly prohibited.

# 3.7 is required for FindVulkan module support in CMake.
cmake_minimum_required(VERSION 3.7)

project(AppEncCuda)

set(APP_SOURCES
 ${CMAKE_CURRENT_SOURCE_DIR}/AppEncCuda.cpp
)

set(NV_ENC_SOURCES
 ${NV_ENC_DIR}/NvEncoder.cpp
 ${NV_ENC_DIR}/NvEncoderCuda.cpp
 ${NV_ENC_DIR}/NvEncoderOutputInVidMemCuda.cpp
)

set(NV_ENC_HDRS
 ${NV_ENC_DIR}/NvEncoder.h
 ${NV_ENC_DIR}/NvEncoderCuda.h
 ${NV_ENC_DIR}/NvEncoderOutputInVidMemCuda.h
 ${NVCODEC_PUBLIC_INTERFACE_DIR}/nvEncodeAPI.h
 ${NVCODEC_UTILS_DIR}/NvCodecUtils.h
 ${NVCODEC_UTILS_DIR}/NvEncoderCLIOptions.h
)

set(NV_ENC_CUDA_UTILS
 ${NVCODEC_UTILS_DIR}/crc.cu
)

source_group( "headers" FILES ${NV_ENC_HDRS} )
source_group( "sources" FILES ${APP_SOURCES} ${NV_ENC_SOURCES} ${NV_ENC_CUDA_UTILS})

find_package(CUDA)
message("CUDA_CUDA_LIBRARY: ${CUDA_CUDA_LIBRARY}")
message("CUDA_TOOLKIT_ROOT_DIR: ${CUDA_TOOLKIT_ROOT_DIR}")

set(CUDA_HOST_COMPILER ${CMAKE_CXX_COMPILER})

set(CUDA_NVCC_FLAGS ${CUDA_NVCC_FLAGS};-gencode arch=compute_50,code=\"sm_50,compute_50\")
if ( CMAKE_COMPILER_IS_GNUCC )
    if(NOT "${CUDA_NVCC_FLAGS}" MATCHES "-std=c\\+\\+11" )
        list(APPEND CUDA_NVCC_FLAGS -std=c++11)
    endif()
endif()

cuda_add_executable(${PROJECT_NAME}  ${APP_SOURCES} ${NV_ENC_SOURCES} ${NV_ENC_CUDA_UTILS} ${NV_ENC_HDRS})

set_target_properties(${PROJECT_NAME} PROPERTIES CUDA_SEPARABLE_COMPILATION ON)

target_include_directories(${PROJECT_NAME} PUBLIC ${CUDA_INCLUDE_DIRS}
 ${NVCODEC_PUBLIC_INTERFACE_DIR}
 ${NVCODEC_UTILS_DIR}
 ${NV_ENC_DIR}
 ${NV_CODEC_DIR}
)

target_link_libraries(${PROJECT_NAME} ${CUDA_CUDA_LIBRARY} ${CMAKE_DL_LIBS} ${NVENCODEAPI_LIB} ${CUVID_LIB})

install(TARGETS ${PROJECT_NAME} RUNTIME DESTINATION ${NVCODEC_SAMPLES_INSTALL_DIR})
if (MSVC)
    add_definitions(-D_CRT_SECURE_NO_WARNINGS)
    set_target_properties( ${PROJECT_NAME} PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${NVCODEC_SAMPLES_INSTALL_DIR}/$<CONFIG>/ )
    install(FILES $<TARGET_PDB_FILE:${PROJECT_NAME}> DESTINATION ${NVCODEC_SAMPLES_INSTALL_DIR} CONFIGURATIONS Debug)
endif()

=== packaging/buildah/opt/nvenc/Samples/AppEncode/AppEncD3D11/CMakeLists.txt ===
# Copyright 2020 NVIDIA Corporation.  All rights reserved.
#
# Please refer to the NVIDIA end user license agreement (EULA) associated
# with this source code for terms and conditions that govern your use of
# this software. Any use, reproduction, disclosure, or distribution of
# this software and related documentation outside the terms of the EULA
# is strictly prohibited.

# 3.7 is required for FindVulkan module support in CMake.
cmake_minimum_required(VERSION 3.7)

project(AppEncD3D11)

set(APP_SOURCES
 ${CMAKE_CURRENT_SOURCE_DIR}/AppEncD3D11.cpp
)

set(NV_ENC_SOURCES
 ${NV_ENC_DIR}/NvEncoder.cpp
 ${NV_ENC_DIR}/NvEncoderD3D11.cpp
 ${NV_ENC_DIR}/NvEncoderOutputInVidMemD3D11.cpp
)

set(NV_ENC_HDRS
 ${NV_ENC_DIR}/NvEncoder.h
 ${NV_ENC_DIR}/NvEncoderD3D11.h
 ${NV_ENC_DIR}/NvEncoderOutputInVidMemD3D11.h
 ${NVCODEC_PUBLIC_INTERFACE_DIR}/nvEncodeAPI.h
 ${NVCODEC_UTILS_DIR}/NvCodecUtils.h
 ${NVCODEC_UTILS_DIR}/NvEncoderCLIOptions.h
 ${NV_APPENC_COMMON_DIR}/AppEncUtils.h
)

source_group( "headers" FILES ${NV_ENC_HDRS} )
source_group( "sources" FILES ${APP_SOURCES} ${NV_ENC_SOURCES} )

add_executable(${PROJECT_NAME}  ${APP_SOURCES} ${NV_ENC_SOURCES} ${NV_ENC_HDRS})

target_include_directories(${PROJECT_NAME} PUBLIC
 ${NVCODEC_PUBLIC_INTERFACE_DIR}
 ${NVCODEC_UTILS_DIR}
 ${NV_CODEC_DIR}
 ${NV_ENC_COMMON_DIR}
)

set(D3D11_LIBS d3d11.lib dxgi.lib d3dcompiler.lib)

target_link_libraries(${PROJECT_NAME} ${D3D11_LIBS} ${CMAKE_DL_LIBS} ${NVENCODEAPI_LIB} )

install(TARGETS ${PROJECT_NAME} RUNTIME DESTINATION ${NVCODEC_SAMPLES_INSTALL_DIR})

if (MSVC)
    add_definitions(-D_CRT_SECURE_NO_WARNINGS)

    set_target_properties( ${PROJECT_NAME} PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${NVCODEC_SAMPLES_INSTALL_DIR}/$<CONFIG>/ )
    install(FILES $<TARGET_PDB_FILE:${PROJECT_NAME}> DESTINATION ${NVCODEC_SAMPLES_INSTALL_DIR} CONFIGURATIONS Debug)
endif()

=== packaging/debian/changelog ===
xpra (4.2-1) UNRELEASED; urgency=low
  * use pinentry for password prompts and ssh prompts
  * nvjpeg encoder
  * gui for starting remote sessions
  * new subcommands: `recover`, `displays`, `list-sessions`, `clean-displays`, `clean-sockets`
  * many fixes:
    - window initial position
    - focus issues
    - non-opengl paint corruption
    - slow rendering on MacOS
    - handle smooth scroll events with wayland clients
    - always lossless screen updates for terminals
    - clipboard timeout
    - peercred auth options
  * support multiple clients using mmap simultaneously with non-default file paths
  * only synchronize xsettings with seamless servers
  * automatic desktop scaling is now disabled
  * workaround for gnome applications starting slowly (documentation)

 -- Antoine Martin <antoine@xpra.org>  Tue, 18 May 2021 23:16:11 +0700

xpra (4.1-1) UNRELEASED; urgency=low
  * Overhauled container based build system
  * Splash screen
  * `run_scaled` utility script
  * Client:
    - header bar option for window control menu
    - generate a qrcode to connect
    - show all keyboard shortcuts
    - progress bar for file transfers
    - GTK cairo backend support for more native bit depths
    - disable xpra's keyboard shortcuts from the system tray menu
    - automatically include the server log in bug reports
  * OpenGL client backend:
    - render at fixed bit depths with the `pixel-depth` option
    - support more bit depths
  * Clipboard:
    - MacOS support for images, more text formats, etc
    - MS Windows support for images
    - wayland clients
  * Server:
    - faster server startup
    - `xpra list-windows` subcommand
    - new window control commands: move / resize and map / unmap
    - remote logging from server to client
    - support window re-stacking
  * `xpra top`:
    - show pids, shortcuts
    - more details in the list view
    - show speed and quality
  * Display:
    - bumped maximum resolution beyond 8K
    - set the initial resolution more easily using the 'resize-display' option
  * Encoding:
    - server side picture downscaling
    - libva hardware accelerated encoding
    - NVENC 30-bit accelerated encoding
    - vpx 30-bit
    - x264 30-bit
    - faster 30-bit RGB subsampling
    - scroll encoding now handled more generically
    - black and white mode
  * Network:
    - IGD / UPNP
    - SO_KEEPALIVE option
    - clients can be queried and controlled using local sockets
    - specify connection attributes using the connection string
    - nested SSH tunnels
    - websocket header modules
    - specify the socket type with socket activation
    - expose the packet flush flag
    - `xpra shell` subcommand for interacting with processes in real time
    - custom group sockets directory permissions and name
  * Testing:
    - better test coverage
    - cleanup output

 -- Antoine Martin <antoine@xpra.org>  Sat, 27 Feb 2021 22:54:51 +0700

xpra (4.0-1) UNRELEASED; urgency=low
  * Drop support for:
    - Python 2, GTK2
    - legacy versions (pre 1.0)
    - weak authentication
  * Network, per socket options:
    - authentication and encryption
    - ssl
    - ssh
    - bind options for client
  * make it easier to send files from the server
  * xpra toolbox subcommand
  * xpra help subcommand
  * xpra top new features
  * faster startup
  * signal handling fixes
  * smoother window resizing
  * refactoring and testing
    - unit tests coverage and fixes
    - completely skip loading unused features at runtime
    - get rid of capabilities data after parsing it
    - better module dependency separation
    - don't convert to a string before we need it
  * more useful window and tray title
  * make it easier to source environment
  * disable desktop animations in desktop mode
  * automatic start-or-upgrade, automatic X11 display rescue
  * support MS Windows OpenSSH server to start shadow
  * more selective use of OpenGL acceleration in client
  * expose server OpenGL capabilities
  * cleaner HTML5 syntax

 -- Antoine Martin <antoine@xpra.org>  Sun, 10 May 2020 14:13:00 +0700

xpra (3.0-1) UNRELEASED; urgency=low
  * Python 3 port complete, now the default: #1571, #2195
  * much nicer HTML5 client user interface: #2269
  * Window handling:
    - smoother window resizing: #478 (OpenGL)
    - honouring gravity: #2217
    - lock them in readonly mode: #2137
  * xpra top subcommand: #2348
  * faster startup:
    - #2347 faster client startup
    - #2341 faster server startup
  * OpenGL:
    - more reliable driver probing: #2204
    - cursor paint support: #1497
    - transparency on MacOS: #1794
  * Encoding:
    - lossless window scrolling: #1320
    - scrolling acceleration for non-OpenGL backends: #2295
    - harden image parsing: #2279
    - workaround slow video encoder initialization (ie: NVENC)
      using replacement frames: #2048
    - avoid loading codecs we don't need: #2344
    - skip some CUDA devices, speedup enumeration: #2415
  * Clipboard:
    - new native clipboard implementations for all platforms: #812
    - HTML5 asynchronous clipboard: #1844
    - HTML5 support for copying images: #2312 (with watermarking)
    - brotli compression for text data: #2289
  * Authentication:
    - modular client authentication handlers: #1796
    - mysql authentication module: #2287
    - generic SQL authentication module: #2288
  * Network:
    - client listen mode: #1022
    - retry to connect until it succeeds or times out: #2346
    - mdns TXT attributes updated at runtime: #2187
    - zeroconf fixes: #2317
    - drop pybonjour: #2297
    - paramiko honours IdentityFile: #2282,
      handles SIGINT better: #2378
    - proxy server fixes for ssl and ssh sockets: #2399, remove spurious options: #2193
    - proxy ping and timeouts: #2408
    - proxy dynamic authentication: #2261
  * Automated Testing:
    - test HTML5 client: #2231
    - many new mixin tests: #1773 (and bugs found)
  * start-new-commands is now enabled by default: #2278,


=== packaging/debian/control ===
Source: xpra
Section: x11
Priority: optional
Maintainer: Antoine Martin <antoine@xpra.org>
X-Python3-Version: >= 3.6
Build-Depends: debhelper (>= 8)
              ,libx11-dev
              ,libxcomposite-dev
              ,libxdamage-dev
              ,libxtst-dev
              ,libxkbfile-dev
              ,libvpx-dev
              ,libx264-dev
              ,libwebp-dev
              ,libturbojpeg-dev
              ,libgtk-3-dev
              ,python3-dev
              ,python3-cairo-dev
              ,python-gi-dev
              ,cython3
              ,libavcodec-dev
              ,libavformat-dev
              ,libswscale-dev
              ,dh-python
              ,libsystemd-dev
              ,libpam-dev
              ,pandoc
Standards-Version: 3.9.3
Homepage: https://xpra.org/
Vcs-Git: https://github.com/Xpra-org/xpra
Vcs-Browser: https://github.com/Xpra-org/xpra


Package: xpra
Conflicts: python2-xpra, python3-xpra
Architecture: any
Depends: ${misc:Depends}, ${python3:Depends}, ${shlibs:Depends}
        ,python3 (>= 3.6)
        ,python3-gi
        ,gir1.2-gtk-3.0
        ,python3-cairo
        ,python3-gi-cairo
# for opengl support:
        ,python3-opengl
# not *strictly* required, but too important to miss:
        ,python3-numpy
# for PNG and JPEG support:
        ,python3-pil
# packet encoder:
        ,python3-rencode
# packet compression:
        ,python3-lz4
# clipboard packet compression:
        ,python3-brotli
# ssl (generate cert), wss:
        ,openssl
#we need a vfb: either Xdummy or Xvfb
#        ,xserver-xorg-video-dummy | xserver-xorg-video-dummy-hwe
        ,xvfb
        ,keyboard-configuration
# fast JPEG client support:
#bionic:        ,libturbojpeg
#focal:        ,libturbojpeg
#groovy:        ,libturbojpeg
#hirsute:        ,libturbojpeg
#buster:         ,libturbojpeg0
#bullseye:         ,libturbojpeg0
# for notifications forwarding and dbus server / proxying:
Recommends: python3-dbus
        ,xpra-html5
# for the proxy server:
        ,python3-setproctitle
#not available?
        ,python3-zeroconf
        ,python3-netifaces
#authentication:
        ,python3-kerberos
        ,python3-gssapi
# audio-related:
        ,python3-gst-1.0
#for printer forwarding:
        ,python3-cups
#for ssh transport:
        ,python3-paramiko
        ,python3-dns
#the start-session GUI:
        ,python3-xdg
        ,python3-pyinotify
#hope that this will allow our status icon to be shown:
        ,gir1.2-appindicator3-0.1
#to be able to resize large svg icons:
        ,gir1.2-rsvg-2.0
# ffmpeg based codecs:
#bionic:        ,libavcodec57
#bionic:        ,libswscale4
#focal:        ,libavcodec58
#focal:        ,libswscale5
#groovy:        ,libavcodec58
#groovy:        ,libswscale5
#hirsute:        ,libavcodec58
#hirsute:        ,libswscale5
#buster:        ,libavcodec57
#buster:        ,libswscale4
#bullseye:        ,libavcodec58
#bullseye:        ,libswscale5
# vpx:
#bionic:        ,libvpx5
#focal:        ,libvpx6
#groovy:        ,libvpx6
#hirsute:        ,libvpx6
#buster:        ,libvpx5
#bullseye:        ,libvpx6
# x264:
#bionic:        ,libx264-152
#focal:        ,libx264-155
#groovy:        ,libx264-160
#hirsute:        ,libx264-160
#buster:        ,libx264-155
#bullseye:        ,libx264-160
# we use dbus for many things - this provides "dbus-launch":
        ,dbus-x11
# AES encryption:
        ,python3-cryptography
#webp
        ,libwebp6
# audio-related:
        ,gstreamer1.0-pulseaudio
        ,gstreamer1.0-alsa
        ,gstreamer1.0-plugins-base
#                 ^^ vorbis ^^
        ,gstreamer1.0-plugins-good
#                  ^^ wavpack, wav, flac, speex ^^
        ,gstreamer1.0-plugins-ugly
#                  ^^ mp3 ^^
#for printer forwarding:
        ,cups-filters
        ,cups-common
        ,cups-pdf
        ,cups-daemon
#for ssh transport:
        ,openssh-client
#for using SSH passwords from the GUI launcher:
        ,sshpass
#most of the examples use an xterm:
        ,xterm
#ability to generate qr codes:
        ,python3-qrencode
Suggests: openssh-server
# for sound forwarding (server side):
        ,pulseaudio
        ,pulseaudio-utils
# for webcam support:
        ,v4l2loopback-dkms
# for CPU percentage in "top"
        ,python-psutil
# to make the system tray work again with gnome-shell:
        ,gnome-shell-extension-top-icons-plus
        ,gnome-shell-extension-appindicator
# password prompts:
        ,pinentry-gnome3
# for webcam support:
        ,python3-opencv
# only useful when connecting using a JSON / YAML only client:
        ,python3-yaml
#nvenc support requires pycuda (and its huge list of dependencies!)
#and the nvencode library:
        ,python3-pycuda, libnvidia-encode1
#python3-lz4 is better and available everywhere now, alternatively use:
        ,python3-lzo
# AES encryption:
        ,python3-cryptography
#better debug output:
#        ,python3-cpuinfo
Description: tool to detach/reattach running X programs
 Xpra gives you the functionality of GNU Screen for X applications.
 .
 It allows the user to view remote X applications on their local machine, and
 disconnect and reconnect from the remote machine without losing the state of
 the running applications.
 .
 Unlike VNC, these applications are "rootless".  They appear as individual
 windows inside your window manager rather than being contained within a single
 window.
 .
 This is the Python3 version (experimental).
